{
	BattleManager.addTextSplit = function(text) {
		//text = SceneManager._scene._logWindow.convertEscapeCharacters(text)
		const maxTextLength = 388;
		let lastIndex = text.lastIndexOf(" ");
		if (SceneManager._scene._logWindow._backBitmap.measureTextWidth(text, true) < maxTextLength || lastIndex < 0) {
			SceneManager._scene._logWindow.push("addText", text, 16)
			//break;
		} else {
			let textBeginning = text.slice(0, lastIndex)
			let textEnding = text.slice(lastIndex + 1)
			for (var i = text.length; i > 0; i--) {
				if (text.charAt(i) != " ") { continue }
				if (SceneManager._scene._logWindow._backBitmap.measureTextWidth(textBeginning, true) > maxTextLength) {
					textBeginning = text.slice(0, i)
					textEnding = text.slice(textBeginning.length + 1)
				}
			}
			SceneManager._scene._logWindow.push("addText", textBeginning, 16)
			SceneManager._scene._logWindow.push("addText", textEnding, 16)
		}
	}
}

{
    let _old_BattleManager_processActionSequence = BattleManager.processActionSequence;
    BattleManager.processActionSequence = function(actionName, actionArgs) {

        // SHOW BATTLE TEXT
        if (actionName.match(/BATTLETEXT/)) {
            return this.actionBattleText(actionArgs);
        }
        return _old_BattleManager_processActionSequence.call(this, actionName, actionArgs);
    };

    // Shows battle text
    BattleManager.actionBattleText = function(actionArgs) {
        if (actionArgs[0]) {
          var subject = this._subject;
          var target = actionArgs[1] ? eval(actionArgs[1]) : this._targets[0].name();
          var message = LanguageManager.getTextData('bd_battletext', actionArgs[0]).text
          message = message.format(subject.name(), target); // %1 = subject, %2 = target/battler
          this.addTextSplit(message);
        } 
    };
}